#include "7144s.h"
#include "define.h"
#include "io.h"
#include "sci.h"

volatile long TimerCount;		// JE^l


void initio(void)
{
	// |[gl
#if CPU==7145
	PA.DR.LONG=(unsigned long int)0x000000;
#else	//CPU7144
	PA.DR.WORD.L=(unsigned short)0x5020;
#endif	//
	PB.DR.WORD=(unsigned short)0x0200;
	PC.DR.WORD=(unsigned short)0x0000;
#if CPU==7145
	PD.DR.LONG=(unsigned long int)0x00000000;
#else	//CPU7144
	PD.DR.WORD.L=(unsigned short)0x0000;
#endif	//
	PE.DRL.WORD=(unsigned short)0xF0E0;
	// |[gI/OWX^
#if CPU==7145
	PFC.PAIORH.WORD		= 0x0000;	// PA *0:IN, 1:OUT
//	0000 0000 0000 0000	PAIORH	l
//	          llll llll
//	          +lll-llll--	PFC.PAIORH.BIT.B23		= 0;	// 0:IN, *1:OUT
//	           +ll-llll--	PFC.PAIORH.BIT.B22		= 0;	// 0:IN, *1:OUT
//	            +l-llll--	PFC.PAIORH.BIT.B21		= 0;	// 0:IN, *1:OUT
//	             +-llll--	PFC.PAIORH.BIT.B20		= 0;	// 0:IN, *1:OUT
//	               +lll--	PFC.PAIORH.BIT.B19		= 0;	// 0:IN, *1:OUT
//	                +ll--	PFC.PAIORH.BIT.B18		= 0;	// 0:IN, *1:OUT
//	                 +l--	PFC.PAIORH.BIT.B17		= 0;	// 0:IN, *1:OUT
//	                  +--	PFC.PAIORH.BIT.B16		= 0;	// 0:IN, *1:OUT
#endif	//CPU7145
	PFC.PAIORL.WORD		= 0x7C20;	// PA *0:IN, 1:OUT
//	0000 0000 0000 0000	PAIORL	l
//	llll llll llll llll
//	+lll-llll-llll-llll--	PFC.PAIORL.BIT.B15		= 0;	// 0:IN, *1:OUT
//	 +ll-llll-llll-llll--	PFC.PAIORL.BIT.B14		= 0;	// 0:IN, *1:OUT
//	  +l-llll-llll-llll--	PFC.PAIORL.BIT.B13		= 0;	// 0:IN, *1:OUT
//	   +-llll-llll-llll--	PFC.PAIORL.BIT.B12		= 0;	// 0:IN, *1:OUT
//	     +lll-llll-llll--	PFC.PAIORL.BIT.B11		= 0;	// 0:IN, *1:OUT
//	      +ll-llll-llll--	PFC.PAIORL.BIT.B10		= 0;	// 0:IN, *1:OUT
//	       +l-llll-llll--	PFC.PAIORL.BIT.B9		= 0;	// 0:IN, *1:OUT
//	        +-llll-llll--	PFC.PAIORL.BIT.B8		= 0;	// 0:IN, *1:OUT
//	          +lll-llll--	PFC.PAIORL.BIT.B7		= 0;	// 0:IN, *1:OUT
//	           +ll-llll--	PFC.PAIORL.BIT.B6		= 0;	// 0:IN, *1:OUT
//	            +l-llll--	PFC.PAIORL.BIT.B5		= 0;	// 0:IN, *1:OUT
//	             +-llll--	PFC.PAIORL.BIT.B4		= 0;	// 0:IN, *1:OUT
//	               +lll--	PFC.PAIORL.BIT.B3		= 0;	// 0:IN, *1:OUT
//	                +ll--	PFC.PAIORL.BIT.B2		= 0;	// 0:IN, *1:OUT
//	                 +l--	PFC.PAIORL.BIT.B1		= 0;	// 0:IN, *1:OUT
//	                  +--	PFC.PAIORL.BIT.B0		= 0;	// 0:IN, *1:OUT
	PFC.PBIOR.WORD		= 0x0300;	// PB *0:IN, 1:OUT
//	0000 0000 0000 0000	PBIOR	l
//	       ll llll llll
//	       +l-llll-llll--	PFC.PBIOR.BIT.B9		= 0;	// 0:IN, *1:OUT
//	        +-llll-llll--	PFC.PBIOR.BIT.B8		= 0;	// 0:IN, *1:OUT
//	          +lll-llll--	PFC.PBIOR.BIT.B7		= 0;	// 0:IN, *1:OUT
//	           +ll-llll--	PFC.PBIOR.BIT.B6		= 0;	// 0:IN, *1:OUT
//	            +l-llll--	PFC.PBIOR.BIT.B5		= 0;	// 0:IN, *1:OUT
//	             +-llll--	PFC.PBIOR.BIT.B4		= 0;	// 0:IN, *1:OUT
//	               +lll--	PFC.PBIOR.BIT.B3		= 0;	// 0:IN, *1:OUT
//	                +ll--	PFC.PBIOR.BIT.B2		= 0;	// 0:IN, *1:OUT
//	                 +l--	PFC.PBIOR.BIT.B1		= 0;	// 0:IN, *1:OUT
//	                  +--	PFC.PBIOR.BIT.B0		= 0;	// 0:IN, *1:OUT
	PFC.PCIOR.WORD		= 0xFFFF;	// PC *0:IN, 1:OUT
//	0000 0000 0000 0000	PCIOR	l
//	llll llll llll llll
//	+lll-llll-llll-llll--	PFC.PCIOR.BIT.B15		= 0;	// 0:IN, *1:OUT
//	 +ll-llll-llll-llll--	PFC.PCIOR.BIT.B14		= 0;	// 0:IN, *1:OUT
//	  +l-llll-llll-llll--	PFC.PCIOR.BIT.B13		= 0;	// 0:IN, *1:OUT
//	   +-llll-llll-llll--	PFC.PCIOR.BIT.B12		= 0;	// 0:IN, *1:OUT
//	     +lll-llll-llll--	PFC.PCIOR.BIT.B11		= 0;	// 0:IN, *1:OUT
//	      +ll-llll-llll--	PFC.PCIOR.BIT.B10		= 0;	// 0:IN, *1:OUT
//	       +l-llll-llll--	PFC.PCIOR.BIT.B9		= 0;	// 0:IN, *1:OUT
//	        +-llll-llll--	PFC.PCIOR.BIT.B8		= 0;	// 0:IN, *1:OUT
//	          +lll-llll--	PFC.PCIOR.BIT.B7		= 0;	// 0:IN, *1:OUT
//	           +ll-llll--	PFC.PCIOR.BIT.B6		= 0;	// 0:IN, *1:OUT
//	            +l-llll--	PFC.PCIOR.BIT.B5		= 0;	// 0:IN, *1:OUT
//	             +-llll--	PFC.PCIOR.BIT.B4		= 0;	// 0:IN, *1:OUT
//	               +lll--	PFC.PCIOR.BIT.B3		= 0;	// 0:IN, *1:OUT
//	                +ll--	PFC.PCIOR.BIT.B2		= 0;	// 0:IN, *1:OUT
//	                 +l--	PFC.PCIOR.BIT.B1		= 0;	// 0:IN, *1:OUT
#if CPU==7145
	PFC.PDIORH.WORD		= 0x0000;	// PD *0:IN, 1:OUT
//	0000 0000 0000 0000	PDIORH	l
//	llll llll llll llll
//	+lll-llll-llll-llll--	PFC.PDIORH.BIT.B31		= 0;	// 0:IN, *1:OUT
//	 +ll-llll-llll-llll--	PFC.PDIORH.BIT.B30		= 0;	// 0:IN, *1:OUT
//	  +l-llll-llll-llll--	PFC.PDIORH.BIT.B29		= 0;	// 0:IN, *1:OUT
//	   +-llll-llll-llll--	PFC.PDIORH.BIT.B28		= 0;	// 0:IN, *1:OUT
//	     +lll-llll-llll--	PFC.PDIORH.BIT.B27		= 0;	// 0:IN, *1:OUT
//	      +ll-llll-llll--	PFC.PDIORH.BIT.B26		= 0;	// 0:IN, *1:OUT
//	       +l-llll-llll--	PFC.PDIORH.BIT.B25		= 0;	// 0:IN, *1:OUT
//	        +-llll-llll--	PFC.PDIORH.BIT.B24		= 0;	// 0:IN, *1:OUT
//	          +lll-llll--	PFC.PDIORH.BIT.B23		= 0;	// 0:IN, *1:OUT
//	           +ll-llll--	PFC.PDIORH.BIT.B22		= 0;	// 0:IN, *1:OUT
//	            +l-llll--	PFC.PDIORH.BIT.B21		= 0;	// 0:IN, *1:OUT
//	             +-llll--	PFC.PDIORH.BIT.B20		= 0;	// 0:IN, *1:OUT
//	               +lll--	PFC.PDIORH.BIT.B19		= 0;	// 0:IN, *1:OUT
//	                +ll--	PFC.PDIORH.BIT.B18		= 0;	// 0:IN, *1:OUT
//	                 +l--	PFC.PDIORH.BIT.B17		= 0;	// 0:IN, *1:OUT
//	                  +--	PFC.PDIORH.BIT.B16		= 0;	// 0:IN, *1:OUT
#endif
	PFC.PDIORL.WORD		= 0x0000;	// PD *0:IN, 1:OUT
//	0000 0000 0000 0000	PDIORL	l
//	llll llll llll llll
//	+lll-llll-llll-llll--	PFC.PDIORL.BIT.B15		= 0;	// 0:IN, *1:OUT
//	 +ll-llll-llll-llll--	PFC.PDIORL.BIT.B14		= 0;	// 0:IN, *1:OUT
//	  +l-llll-llll-llll--	PFC.PDIORL.BIT.B13		= 0;	// 0:IN, *1:OUT
//	   +-llll-llll-llll--	PFC.PDIORL.BIT.B12		= 0;	// 0:IN, *1:OUT
//	     +lll-llll-llll--	PFC.PDIORL.BIT.B11		= 0;	// 0:IN, *1:OUT
//	      +ll-llll-llll--	PFC.PDIORL.BIT.B10		= 0;	// 0:IN, *1:OUT
//	       +l-llll-llll--	PFC.PDIORL.BIT.B9		= 0;	// 0:IN, *1:OUT
//	        +-llll-llll--	PFC.PDIORL.BIT.B8		= 0;	// 0:IN, *1:OUT
//	          +lll-llll--	PFC.PDIORL.BIT.B7		= 0;	// 0:IN, *1:OUT
//	           +ll-llll--	PFC.PDIORL.BIT.B6		= 0;	// 0:IN, *1:OUT
//	            +l-llll--	PFC.PDIORL.BIT.B5		= 0;	// 0:IN, *1:OUT
//	             +-llll--	PFC.PDIORL.BIT.B4		= 0;	// 0:IN, *1:OUT
//	               +lll--	PFC.PDIORL.BIT.B3		= 0;	// 0:IN, *1:OUT
//	                +ll--	PFC.PDIORL.BIT.B2		= 0;	// 0:IN, *1:OUT
//	                 +l--	PFC.PDIORL.BIT.B1		= 0;	// 0:IN, *1:OUT
//	                  +--	PFC.PDIORL.BIT.B0		= 0;	// 0:IN, *1:OUT
	PFC.PEIORL.WORD		= 0xF0E0;	// PE *0:IN, 1:OUT
//	0000 0000 0000 0000	PEIORL	l
//	llll llll llll llll
//	+lll-llll-llll-llll--	PFC.PEIORL.BIT.B15		= 0;	// 0:IN, *1:OUT
//	 +ll-llll-llll-llll--	PFC.PEIORL.BIT.B14		= 0;	// 0:IN, *1:OUT
//	  +l-llll-llll-llll--	PFC.PEIORL.BIT.B13		= 0;	// 0:IN, *1:OUT
//	   +-llll-llll-llll--	PFC.PEIORL.BIT.B12		= 0;	// 0:IN, *1:OUT
//	     +lll-llll-llll--	PFC.PEIORL.BIT.B11		= 0;	// 0:IN, *1:OUT
//	      +ll-llll-llll--	PFC.PEIORL.BIT.B10		= 0;	// 0:IN, *1:OUT
//	       +l-llll-llll--	PFC.PEIORL.BIT.B9		= 0;	// 0:IN, *1:OUT
//	        +-llll-llll--	PFC.PEIORL.BIT.B8		= 0;	// 0:IN, *1:OUT
//	          +lll-llll--	PFC.PEIORL.BIT.B7		= 0;	// 0:IN, *1:OUT
//	           +ll-llll--	PFC.PEIORL.BIT.B6		= 0;	// 0:IN, *1:OUT
//	            +l-llll--	PFC.PEIORL.BIT.B5		= 0;	// 0:IN, *1:OUT
//	             +-llll--	PFC.PEIORL.BIT.B4		= 0;	// 0:IN, *1:OUT
//	               +lll--	PFC.PEIORL.BIT.B3		= 0;	// 0:IN, *1:OUT
//	                +ll--	PFC.PEIORL.BIT.B2		= 0;	// 0:IN, *1:OUT
//	                 +l--	PFC.PEIORL.BIT.B1		= 0;	// 0:IN, *1:OUT
	// |[gI/OWX^ݒ

	MST.CR2.BIT._CMT = 0;          // CMTX^oC畜A
// CMT0 (1msEFCgp)
	CMT0.CMCSR.BIT.CMIE = 0;  // 荞݋֎~
	CMT0.CMCSR.BIT.CKS = 1;   // /32
	CMT0.CMCSR.BIT.CMF = 0;   // tONA
	CMT0.CMCNT = 0;           // RyA}b`JE^NA
//	CMT0.CMCOR = 875;         // RyA}b`RX^gJE^ 1ms
	CMT0.CMCOR = PCLOCK/(32*1000);         // RyA}b`RX^gJE^ 1ms
// CMT1&X^[g  (1sC^[o荞݃JE^p)
	cmt1_init(1,1);	//ŏP1mS 
#if RS1
// VA(SCI1) 57600[bps]
	SCI1_INIT (br57600, 1, 8, 0, 1);
	SCI1_IN_DATA_CLEAR();
	SCI1_OUT_DATA_CLEAR();
#endif
// Xe[^XWX^̊荞݃}XNݒ
	SetSRReg (0);
// LCD
#if LCD
	reset_lcd();
#endif
	//
}

/************************************************************************
*y֐z     cmt1_init		CMT1ij				*
*y  z     int				start	0:STOP	1:START					*
*				int				Cycle	1=1mS	10=10mS	max=50,min=1	*
*y^[lz					Ȃ									*
*	덷
*	28M			0%
*	24M			0%
*	22.1184M	0.029%
************************************************************************/
void cmt1_init(int start,int Cycle)
{
	CMT.CMSTR.BIT.STR1 = 0;		// CMT1JEg~
	TimerCount=0;
	CMT1.CMCSR.BIT.CMIE = 1;  // 荞݋
	CMT1.CMCSR.BIT.CKS = 1;   // /32
	CMT1.CMCSR.BIT.CMF = 0;   // tONA
	CMT1.CMCNT = 0;           // RyA}b`JE^NA
//	CMT1.CMCOR = 875*Cycle;   // RyA}b`RX^gJE^
	CMT1.CMCOR = (PCLOCK/(32*1000))*Cycle;   // RyA}b`RX^gJE^
	INTC.IPRG.BIT._CMT1 = 1;  // CMT1RyA}b`荞ݗD惌x CMT1=1
	CMT.CMSTR.BIT.STR1 = start;		// CMT1JEgJn
}
/*--------------------------------------------------------------*/
/* RyA}b`^C}(CMT1)荞݂ɂ1or10msJE^         */
/*--------------------------------------------------------------*/
#pragma interrupt
void INT_CMT_CMT1(void)	// int_cmi1 (void)	// 荞ݏ֐
{
//	if(CMT1.CMCSR.BIT.CMF == 1) CMT1.CMCSR.BIT.CMF = 0;		// tONA
	CMT1.CMCSR.BIT.CMF &= 0;		// tONA
	TimerCount++;	// JE^CNg
}
/************************************************************************
*y֐z     uWait													*
*y  z     long			time	Waitliʂrj				*
*				CLK28M
************************************************************************/
/* 1usPʃEFCg              */
void uWait(long time)
{
//	long	i,j;
//	j=time;
//	j<<=2;
//	for(i=0L;i<j;i++) nop();		//uS Wait
//	time<<=2;
//	while(time--) nop();
	while(time--){
		nop();		nop();		nop();		nop();
		nop();		nop();		nop();		nop();
		nop();		nop();		nop();		nop();
		nop();		nop();		nop();		nop();
		nop();		nop();		nop();		nop();
		nop();
	}

}
/************************************************************************
*y֐z     wait													*
*y  z     long			num		Waitlirj				*
************************************************************************/
/* RyA}b`^C}(CMT0)ɂ1msPʃEFCg              */
void wait(long num)
{
	long i;

	CMT.CMSTR.BIT.STR0 = 1;   // JEgJn
	for (i = 0L; i < num; i++) {
		while (!CMT0.CMCSR.BIT.CMF) ;
		CMT0.CMCSR.BIT.CMF = 0;
	}
	CMT.CMSTR.BIT.STR0 = 0;   // JEg~
}
