#ifndef	_SCI_H_
#define	_SCI_H_
/*--------------------------------------------------------------*/
/* VAʐM֐(FIFOobt@t)                             */
/*--------------------------------------------------------------*/
#define SCI0_BUFF_SIZE	20
#define SCI1_BUFF_SIZE	20
#define SCI2_BUFF_SIZE	20
#define SCI3_BUFF_SIZE	20

#if PCLOCK==20000000
// I/ONbN20MHz
typedef enum {			//((PCLOCK / 32) / bps) - 1 +0.5
  br4800   = 129,	// 0.16%
  br9600   = 64,	// 0.16%
  br19200  = 32,	//-1.36%
  br38400  = 15,	// 1.73%
  br57600  = 10,	//-1.36%
  br115200 = 4,		// 8.51%
  brEXT    = 255
} TBaudRate;
#endif
#if PCLOCK==22118400
// I/ONbN22.1184MHz
typedef enum {			//((PCLOCK / 32) / bps) - 1 +0.5
  br4800   = 143,	//0.00%
  br9600   = 71,	//0.00%
  br19200  = 35,	//0.00%
  br38400  = 17,	//0.00%
  br57600  = 11,	//0.00%
  br115200 = 5,		//0.00%
  br230400 = 2,		//0.00%
  br345600 = 1,		//0.00%	br460800 = 1,		//-2.5%
  br691200 = 0,		//0.00%	br921600 = 0,		//-2.5%
  brEXT    = 255
} TBaudRate;
#endif
#if PCLOCK==24000000
// I/ONbN24MHz
typedef enum {			//((PCLOCK / 32) / bps) - 1 +0.5
  br4800   = 155,	// 0.16%
  br9600   = 77,	// 0.16%
  br19200  = 38,	// 0.16%
  br38400  = 19,	//-2.34%
  br57600  = 12,	// 0.16%
  br115200 = 6,		//-6.99%
  br115200_EXT = 255    // SCK[qgp
} TBaudRate;
#endif
#if PCLOCK==24576000
// I/ONbN24.576MHz
typedef enum {			//((PCLOCK / 32) / bps) - 1 +0.5
  br4800   = 159,	// 0.00%
  br9600   = 79,	// 0.00%
  br19200  = 39,	// 0.00%
  br38400  = 19,	// 0.00%
  br57600  = 12,	// 2.56%
  br115200 = 6,		//-4.76%
  brEXT    = 255
} TBaudRate;
#endif
#if PCLOCK==25000000
// I/ONbN25MHz
typedef enum {			//((PCLOCK / 32) / bps) - 1 +0.5
  br4800   = 162,	//-0.15%
  br9600   = 80,	// 0.47%
  br19200  = 40,	//-0.76%
  br38400  = 19,	// 1.73%
  br57600  = 13,	//-3.12%
  br115200 = 6,		//-3.12%
  brEXT    = 255
} TBaudRate;
#endif
#if PCLOCK==32000000
// I/ONbN32MHz
typedef enum {			//((PCLOCK / 32) / bps) - 1 +0.5
  br4800    = 207,	// 0.16%
  br9600    = 103,	// 0.16%
  br19200   = 51,	// 0.16%
  br38400   = 25,	// 0.16%
  br57600   = 16,	// 2.12%
  br115200  = 8,	// 3.55%
  br200k    = 4,	// 0.00%
  br250k    = 3,	// 0.00%
  br500k    = 1,	// 0.00%
  br1M      = 0,	// 0.00%
  brEXT     = 255
} TBaudRate;
#endif
#if PCLOCK==40000000
// I/ONbN40MHz
typedef enum {			//((PCLOCK / 32) / bps) - 1 +0.5
  br4800   = 32,	//-1.36%	SMR.CKS=1
  br9600   = 129,	// 0.16%	SMR.CKS=0
  br19200  = 64,	// 0.16%	SMR.CKS=0
  br38400  = 32,	//-1.36%	SMR.CKS=0
  br57600  = 21,	//-1.36%	SMR.CKS=0
  br115200 = 10,	//-1.36%	SMR.CKS=0
  brEXT    = 255
} TBaudRate;
#endif

typedef struct {
	struct {
		char  *buf;
		short wp;
		short rp;
		short maxlen;
	} tx;
	struct {
		char  *buf;
		short wp;
		short rp;
		short maxlen;
	} rx;
} SCIFIFO;
#if	RS0	// SCI0
extern void SCI0_INIT(TBaudRate,char,unsigned char,unsigned char,unsigned char);		//rs_init
extern short SCI0_OUT_DATA_CHECK(void);		// rs_tx_buff
extern short SCI0_IN_DATA_CHECK(void);		// rs_rx_buff
extern void SCI0_IN_DATA_CLEAR(void);		// rs_rx_purge
extern void SCI0_OUT_DATA_CLEAR(void);		// rs_tx_purge

extern void SCI0_OUT_DATA(char);			// rs_putc
extern void SCI0_OUT_STRING(char *);		// rs_puts
extern void SCI0_OUT_STRINGB(char *,short);	// rs_putsb
extern void SCI0_OUT_STRINGB2(char *,int);	// rs_putsb2
extern char SCI0_IN_DATA(void);				// rs_getc
extern short SCI0_IN_STRING(char *,short);	// rs_gets
extern int SCI0_IN_STRING2(char *,int);		// rs_gets2
extern int SCI0_PRINTF(const char *,...);	// rs_printf

//extern void INT_SCI0_ERI0(void);			// rs_eri
//extern void INT_SCI0_RXI0(void);			// rs_rxi
//extern void INT_SCI0_TXI0(void);			// rs_txi
//extern void INT_SCI0_ERI0(void);			// int_tei
//extern char txb0[SCI0_BUFF_SIZE], rxb0[SCI0_BUFF_SIZE];
#define	SCI0Dprintf(var)	SCI0_PRINTF(#var"=%d"CRLF, var) 
#define	SCI0Xprintf(var)	SCI0_PRINTF(#var"=%X"CRLF, var) 
#endif	//RS0
#if	RS1	// SCI1
extern void SCI1_INIT(TBaudRate, char,unsigned char,unsigned char,unsigned char);		//rs_init
extern short SCI1_OUT_DATA_CHECK(void);		// rs_tx_buff
extern short SCI1_IN_DATA_CHECK(void);		// rs_rx_buff
extern void SCI1_IN_DATA_CLEAR(void);		// rs_rx_purge
extern void SCI1_OUT_DATA_CLEAR(void);		// rs_tx_purge

extern void SCI1_OUT_DATA(char);			// rs_putc
extern void SCI1_OUT_STRING(char *);		// rs_puts
extern void SCI1_OUT_STRINGB(char *,short);	// rs_putsb
extern void SCI1_OUT_STRINGB2(char *,int);	// rs_putsb2
extern char SCI1_IN_DATA(void);				// rs_getc
extern short SCI1_IN_STRING(char *,short);	// rs_gets
extern int SCI1_IN_STRING2(char *,int);		// rs_gets2
extern int SCI1_PRINTF(const char *,...);	// rs_printf

//extern void INT_SCI1_ERI1(void);			// rs_eri
//extern void INT_SCI1_RXI1(void);			// rs_rxi
//extern void INT_SCI1_TXI1(void);			// rs_txi
//extern void INT_SCI1_ERI1(void);			// int_tei
//extern char txb1[SCI1_BUFF_SIZE], rxb1[SCI1_BUFF_SIZE];
#define	SCI1Dprintf(var)	SCI1_PRINTF(#var"=%d"CRLF, var) 
#define	SCI1Xprintf(var)	SCI1_PRINTF(#var"=%X"CRLF, var) 
#endif	//RS1
#if	RS2	// SCI2
extern void SCI2_INIT(TBaudRate, char,unsigned char,unsigned char,unsigned char);		//rs_init
extern short SCI2_OUT_DATA_CHECK(void);		// rs_tx_buff
extern short SCI2_IN_DATA_CHECK(void);		// rs_rx_buff
extern void SCI2_IN_DATA_CLEAR(void);		// rs_rx_purge
extern void SCI2_OUT_DATA_CLEAR(void);		// rs_tx_purge

extern void SCI2_OUT_DATA(char);			// rs_putc
extern void SCI2_OUT_STRING(char *);		// rs_puts
extern void SCI2_OUT_STRINGB(char *,short);	// rs_putsb
extern void SCI2_OUT_STRINGB2(char *,int);	// rs_putsb2
extern char SCI2_IN_DATA(void);				// rs_getc
extern short SCI2_IN_STRING(char *,short);	// rs_gets
extern int SCI2_IN_STRING2(char *,int);		// rs_gets2
extern int SCI2_PRINTF(const char *,...);	// rs_printf

//extern void INT_SCI2_ERI2(void);			// rs_eri
//extern void INT_SCI2_RXI2(void);			// rs_rxi
//extern void INT_SCI2_TXI2(void);			// rs_txi
//extern void INT_SCI2_ERI2(void);			// int_tei
//extern char txb2[SCI2_BUFF_SIZE], rxb2[SCI2_BUFF_SIZE];
#define	SCI2Dprintf(var)	SCI2_PRINTF(#var"=%d"CRLF, var) 
#define	SCI2Xprintf(var)	SCI2_PRINTF(#var"=%X"CRLF, var) 
#endif	//RS2
#if	RS3	// SCI3
extern void SCI3_INIT(TBaudRate, char,unsigned char,unsigned char,unsigned char);		//rs_init
extern short SCI3_OUT_DATA_CHECK(void);		// rs_tx_buff
extern short SCI3_IN_DATA_CHECK(void);		// rs_rx_buff
extern void SCI3_IN_DATA_CLEAR(void);		// rs_rx_purge
extern void SCI3_OUT_DATA_CLEAR(void);		// rs_tx_purge

extern void SCI3_OUT_DATA(char);			// rs_putc
extern void SCI3_OUT_STRING(char *);		// rs_puts
extern void SCI3_OUT_STRINGB(char *,short);	// rs_putsb
extern void SCI3_OUT_STRINGB2(char *,int);	// rs_putsb2
extern char SCI3_IN_DATA(void);				// rs_getc
extern short SCI3_IN_STRING(char *,short);	// rs_gets
extern int SCI3_IN_STRING2(char *,int);		// rs_gets2
extern int SCI3_PRINTF(const char *,...);	// rs_printf

//extern void INT_SCI3_ERI3(void);			// rs_eri
//extern void INT_SCI3_RXI3(void);			// rs_rxi
//extern void INT_SCI3_TXI3(void);			// rs_txi
//extern void INT_SCI3_ERI3(void);			// int_tei
//extern char txb3[SCI3_BUFF_SIZE], rxb3[SCI3_BUFF_SIZE];
#define	SCI3Dprintf(var)	SCI3_PRINTF(#var"=%d"CRLF, var) 
#define	SCI3Xprintf(var)	SCI3_PRINTF(#var"=%X"CRLF, var) 
#endif	//RS3

#endif	//_SCI_H_
