/****************************************************************
KPIT Cummins Infosystems Ltd, Pune, India. - 05-Sept-2005.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*****************************************************************/

#include "inthandler.h"

extern void start (void);     /* Startup code (in start.s)  */
extern void stack (void);  /* stack from linker script   */

/**----------------------------------
**  Typedef for the function pointer
**-----------------------------------*/

typedef void (*fp) (void);
#define VECT_SECT          __attribute__ ((section (".vects")))

const fp HardwareVectors[] VECT_SECT = {
  start,                    /* 0  Power-on reset, Program counter (PC) */
  (fp) stack,               /* 1  Power-on reset, Stack pointer (SP)   */
INT_Manual_Reset_PC,
(fp) stack,		//INT_Manual_Reset_SP,
INT_Illegal_code,
(fp)0,			/*Reserved 5*/
INT_Illegal_slot,
(fp)0,			/*Reserved 7*/
(fp)0,			/*Reserved 8*/
INT_CPU_Address,
INT_DTC_Address,
INT_NMI,
INT_User_Break,
(fp)0,			/*Reserved 13*/
INT_H_UDI,
(fp)0,			/*Reserved 15*/
(fp)0,			/*Reserved 16*/
(fp)0,			/*Reserved 17*/
(fp)0,			/*Reserved 18*/
(fp)0,			/*Reserved 19*/
(fp)0,			/*Reserved 20*/
(fp)0,			/*Reserved 21*/
(fp)0,			/*Reserved 22*/
(fp)0,			/*Reserved 23*/
(fp)0,			/*Reserved 24*/
(fp)0,			/*Reserved 25*/
(fp)0,			/*Reserved 26*/
(fp)0,			/*Reserved 27*/
(fp)0,			/*Reserved 28*/
(fp)0,			/*Reserved 29*/
(fp)0,			/*Reserved 30*/
(fp)0,			/*Reserved 31*/
INT_TRAPA32,
INT_TRAPA33,
INT_TRAPA34,
INT_TRAPA35,
INT_TRAPA36,
INT_TRAPA37,
INT_TRAPA38,
INT_TRAPA39,
INT_TRAPA40,
INT_TRAPA41,
INT_TRAPA42,
INT_TRAPA43,
INT_TRAPA44,
INT_TRAPA45,
INT_TRAPA46,
INT_TRAPA47,
INT_TRAPA48,
INT_TRAPA49,
INT_TRAPA50,
INT_TRAPA51,
INT_TRAPA52,
INT_TRAPA53,
INT_TRAPA54,
INT_TRAPA55,
INT_TRAPA56,
INT_TRAPA57,
INT_TRAPA58,
INT_TRAPA59,
INT_TRAPA60,
INT_TRAPA61,
INT_TRAPA62,
INT_TRAPA63,
INT_IRQ0,
INT_IRQ1,
INT_IRQ2,
INT_IRQ3,
INT_IRQ4,
INT_IRQ5,
INT_IRQ6,
INT_IRQ7,
INT_DMAC_DEI0,
(fp)0,			/*Reserved 73*/
(fp)0,			/*Reserved 74*/
(fp)0,			/*Reserved 75*/
INT_DMAC_DEI1,
(fp)0,			/*Reserved 77*/
(fp)0,			/*Reserved 78*/
(fp)0,			/*Reserved 79*/
INT_DMAC_DEI2,
(fp)0,			/*Reserved 81*/
(fp)0,			/*Reserved 82*/
(fp)0,			/*Reserved 83*/
INT_DMAC_DEI3,
(fp)0,			/*Reserved 85*/
(fp)0,			/*Reserved 86*/
(fp)0,			/*Reserved 87*/
INT_MTU0_TGIA0,
INT_MTU0_TGIB0,
INT_MTU0_TGIC0,
INT_MTU0_TGID0,
INT_MTU0_TCIV0,
(fp)0,			/*Reserved 93*/
(fp)0,			/*Reserved 94*/
(fp)0,			/*Reserved 95*/
INT_MTU1_TGIA1,
INT_MTU1_TGIB1,
(fp)0,			/*Reserved 98*/
(fp)0,			/*Reserved 99*/
INT_MTU1_TCIV1,
INT_MTU1_TCIU1,
(fp)0,			/*Reserved 102*/
(fp)0,			/*Reserved 103*/
INT_MTU2_TGIA2,
INT_MTU2_TGIB2,
(fp)0,			/*Reserved 106*/
(fp)0,			/*Reserved 107*/
INT_MTU2_TCIV2,
INT_MTU2_TCIU2,
(fp)0,			/*Reserved 110*/
(fp)0,			/*Reserved 111*/
INT_MTU3_TGIA3,
INT_MTU3_TGIB3,
INT_MTU3_TGIC3,
INT_MTU3_TGID3,
INT_MTU3_TCIV3,
(fp)0,			/*Reserved 117*/
(fp)0,			/*Reserved 118*/
(fp)0,			/*Reserved 119*/
INT_MTU4_TGIA4,
INT_MTU4_TGIB4,
INT_MTU4_TGIC4,
INT_MTU4_TGID4,
INT_MTU4_TCIV4,
(fp)0,			/*Reserved 125*/
(fp)0,			/*Reserved 126*/
(fp)0,			/*Reserved 127*/
INT_SCI0_ERI0,
INT_SCI0_RXI0,
INT_SCI0_TXI0,
INT_SCI0_TEI0,
INT_SCI1_ERI1,
INT_SCI1_RXI1,
INT_SCI1_TXI1,
INT_SCI1_TEI1,
INT_ADI0,
INT_ADI1,
(fp)0,			/*Reserved 138*/
(fp)0,			/*Reserved 139*/
INT_DTC_SWDTEND,
(fp)0,			/*Reserved 141*/
(fp)0,			/*Reserved 142*/
(fp)0,			/*Reserved 143*/
INT_CMT_CMT0,
(fp)0,			/*Reserved 145*/
(fp)0,			/*Reserved 146*/
(fp)0,			/*Reserved 147*/
INT_CMT_CMT1,
(fp)0,			/*Reserved 149*/
(fp)0,			/*Reserved 150*/
(fp)0,			/*Reserved 151*/
INT_INT_WDT_ITI,
INT_BSC_CMI,
(fp)0,			/*Reserved 154*/
(fp)0,			/*Reserved 155*/
INT_MTUOEI,
(fp)0,			/*Reserved 157*/
(fp)0,			/*Reserved 158*/
(fp)0,			/*Reserved 159*/
(fp)0,			/*Reserved 160*/
(fp)0,			/*Reserved 161*/
(fp)0,			/*Reserved 162*/
(fp)0,			/*Reserved 163*/
(fp)0,			/*Reserved 164*/
(fp)0,			/*Reserved 165*/
(fp)0,			/*Reserved 166*/
(fp)0,			/*Reserved 167*/
INT_SCI2_ERI2,		/*Reserved 168*/
INT_SCI2_RXI2,		/*Reserved 169*/
INT_SCI2_TXI2,		/*Reserved 170*/
INT_SCI2_TEI2,		/*Reserved 171*/
INT_SCI3_ERI3,		/*Reserved 172*/
INT_SCI3_RXI3,		/*Reserved 173*/
INT_SCI3_TXI3,		/*Reserved 174*/
INT_SCI3_TEI3,		/*Reserved 175*/
(fp)0,			/*Reserved 176*/
(fp)0,			/*Reserved 177*/
(fp)0,			/*Reserved 178*/
(fp)0,			/*Reserved 179*/
(fp)0,			/*Reserved 180*/
(fp)0,			/*Reserved 181*/
(fp)0,			/*Reserved 182*/
(fp)0,			/*Reserved 183*/
(fp)0,			/*Reserved 184*/
(fp)0,			/*Reserved 185*/
(fp)0,			/*Reserved 186*/
(fp)0,			/*Reserved 187*/
(fp)0,			/*Reserved 188*/
(fp)0,			/*Reserved 189*/
(fp)0,			/*Reserved 190*/
(fp)0,			/*Reserved 191*/
INT_IIC0RM,		/*Reserved 192*/
(fp)0,			/*Reserved 193*/
(fp)0,			/*Reserved 194*/
(fp)0,			/*Reserved 195*/
(fp)0,			/*Reserved 196*/
(fp)0,			/*Reserved 197*/
(fp)0,			/*Reserved 198*/
(fp)0,			/*Reserved 199*/
(fp)0,			/*Reserved 200*/
(fp)0,			/*Reserved 201*/
(fp)0,			/*Reserved 202*/
(fp)0,			/*Reserved 203*/
(fp)0,			/*Reserved 204*/
(fp)0,			/*Reserved 205*/
(fp)0,			/*Reserved 206*/
(fp)0,			/*Reserved 207*/
(fp)0,			/*Reserved 208*/
(fp)0,			/*Reserved 209*/
(fp)0,			/*Reserved 210*/
(fp)0,			/*Reserved 211*/
(fp)0,			/*Reserved 212*/
(fp)0,			/*Reserved 213*/
(fp)0,			/*Reserved 214*/
(fp)0,			/*Reserved 215*/
(fp)0,			/*Reserved 216*/
(fp)0,			/*Reserved 217*/
(fp)0,			/*Reserved 218*/
(fp)0,			/*Reserved 219*/
(fp)0,			/*Reserved 220*/
(fp)0,			/*Reserved 221*/
(fp)0,			/*Reserved 222*/
(fp)0,			/*Reserved 223*/
(fp)0,			/*Reserved 224*/
(fp)0,			/*Reserved 225*/
(fp)0,			/*Reserved 226*/
(fp)0,			/*Reserved 227*/
(fp)0,			/*Reserved 228*/
(fp)0,			/*Reserved 229*/
(fp)0,			/*Reserved 230*/
(fp)0,			/*Reserved 231*/
(fp)0,			/*Reserved 232*/
(fp)0,			/*Reserved 233*/
(fp)0,			/*Reserved 234*/
(fp)0,			/*Reserved 235*/
(fp)0,			/*Reserved 236*/
(fp)0,			/*Reserved 237*/
(fp)0,			/*Reserved 238*/
(fp)0,			/*Reserved 239*/
(fp)0,			/*Reserved 240*/
(fp)0,			/*Reserved 241*/
(fp)0,			/*Reserved 242*/
(fp)0,			/*Reserved 243*/
(fp)0,			/*Reserved 244*/
(fp)0,			/*Reserved 245*/
(fp)0,			/*Reserved 246*/
(fp)0,			/*Reserved 247*/
(fp)0,			/*Reserved 248*/
(fp)0,			/*Reserved 249*/
(fp)0,			/*Reserved 250*/
(fp)0,			/*Reserved 251*/
(fp)0,			/*Reserved 252*/
(fp)0,			/*Reserved 253*/
(fp)0,			/*Reserved 254*/
(fp)0,			/*Reserved 255*/
};
